module.exports = function () {
  const strictModePaths = new Set();

  function isUseStrict(directive) {
    return directive.value.value === 'use strict';
  }

  return {
    pre() {
      strictModePaths.clear();
    },
    visitor: {
      Directive(path) {
        if (isUseStrict(path.node)) {
          strictModePaths.add(path);
        }
      },
      Program: {
        exit(path) {
          for (const directivePath of strictModePaths) {
            directivePath.remove();
          }
        }
      }
    },
    post() {
      strictModePaths.clear();
    }
  };
};